/*
 *   @(#) MPEG-I Video Decoder 1.0 Demicron (demicron@demicron.com)
 *
 *   P_MPEGApp.java   2002-08-20
 *
 *   Copyright (C) 2002  Demicron
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


/**
 *   The Display interface that a displayer must implement.
 */
public interface Displayable
{
	/**
	 *   Set the display size
	 */
	//void setDisplaySize(int width, int height);

	public long getTime();

	/**
	 *   Set the video image data source
	 */
	void setImageSource(PixProducer imagesource);

	/**
	 *   Update the time info
	 */
	//void updateTime(int hour, int minute, int second);

	/**
	 *   Update the frame info
	 */
	//void updateFrame();

	/**
	 *   Next image in the imagesource is ready to display
	 */
	void nextImage();
}